Unit fta4r_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, FTA3R_p;

procedure fta4r(var ARRAY_ :Array of Real; N :Integer; IREG :Integer); 

implementation

procedure fta4r(var ARRAY_ :Array of Real; N :Integer; IREG :Integer);
var
M,J,NJ1,N1 :Integer;
Y1,Y2,SUM,R :Real;
WR,WI,WPR,WPI,WTEMP,THETA :Extended;
const
SYS001 :Extended = 3.1415926535897932384626433832795;
ONE :Extended = 1.0e0;
ZERO :Extended = 0.0e0;
TWO :Extended = 2.0e0;
HALF :Extended = 0.5e0;
Z :Real = 0.0;
H :Real = 0.5;
T :Real = 2.0;
label
_10,_20,_30,_40;
begin
THETA := SYS001/(N);
WR := ONE;
WI := ZERO;
WPR := -TWO*IntPower(Sin(HALF*THETA),2);
WPI := Sin(THETA);
ARRAY_[0] := Z;
M := Trunc( N/2 );
for J:=1 to M do
 begin
  WTEMP := WR;
  WR := WR*WPR-WI*WPI+WR;
  WI := WI*WPR+WTEMP*WPI+WI;
  NJ1 := N-J+1;
  Y1 := WI*(ARRAY_[J+0]+ARRAY_[NJ1-1]);
  Y2 := H*(ARRAY_[J+0]-ARRAY_[NJ1-1]);
  ARRAY_[J+0] := Y1+Y2;
  ARRAY_[NJ1-1] := Y1-Y2;
_10:
 end;
FTA3R(ARRAY_,M,1);
SUM := Z;
ARRAY_[0] := H*ARRAY_[0];
ARRAY_[1] := Z;
N1 := N-1;
J := 1;
while ( J<=N1 ) do
 begin
  SUM := SUM+ARRAY_[J-1];
  ARRAY_[J-1] := ARRAY_[J+0];
  ARRAY_[J+0] := SUM;
_20:
  inc(J,2);
 end;
if ( IREG = 1 ) 
 then goto _40;
R := T/(N);
for J:=1 to N do
 begin
  ARRAY_[J-1] := R*ARRAY_[J-1];
_30:
 end;
_40:
end;

end.
